# SPDX-License-Identifier: Unlicense
# SPDX-FileCopyrightText: 2022 Freifunk Chemnitz e.V. <info@chemnitz.freifunk.net>
---
default:
  image: debian:buster
  before_script:
    - echo -e "\e[0Ksection_start:`date +%s`:preparation[collapsed=true]\r\e[0Kprepare build environment"
    - apt-get update
    - apt-get -y install build-essential curl gawk git libncurses-dev lua-check python3 shellcheck time unzip wget rsync subversion qemu-utils zlib1g-dev libssl-dev
    - rm -rf ../gluon
    - git clone https://github.com/freifunk-gluon/gluon.git ../gluon
    - cd ../gluon
    - git checkout v2022.1.4
    - ln -s ../site-ffc site
    - echo -e "\e[0Ksection_end:`date +%s`:preparation\r\e[0K"

stages:
  - lint
  - build

workflow:
  rules:
    - if: '$CI_COMMIT_BRANCH != "$CI_DEFAULT_BRANCH"'

check-siteconf:
  image: debian:sid
  stage: lint
  script:
    - make lint-lua V=s
    - make lint-sh V=s

build-gluon:
  stage: build
  tags: [gluon]
  variables:
    BROKEN: 1
    FORCE_UNSAFE_CONFIGURE: 1
  script:
    - make update
    - export DEFAULT_GLUON_RELEASE="b$(date '+%Y%m%d')"
    - for target in $(make list-targets); do GLUON_TARGET=${target} make -j$(nproc || printf 2); done
    - make manifest
    - mkdir ~/.ssh
    - chmod 700 ~/.ssh
    - wget "https://gitlab.com/gitlab-org/incubation-engineering/devops-for-mobile-apps/load-secure-files/-/raw/main/installer"
    - bash installer
    - echo "bequerel.chemnitz.freifunk.net ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIJU8AcDfGLYaH6Yi0fL7Ddj5EK43JgrixJNIE/PAaFIm" > ~/.ssh/known_hosts
    - sftp -4 -i .secure_files/id_ed25519 jenkins@bequerel.chemnitz.freifunk.net <<< "mkdir firmware/nightly/$(date --iso-8601=date)"
    - scp -4 -i .secure_files/id_ed25519 -r output/images/* jenkins@bequerel.chemnitz.freifunk.net:~/firmware/nightly/$(date --iso-8601=date)
